Index: configure.ac
===================================================================
--- configure.ac	(revision 12872df33639e521d4b0225d6064ea91bd4f18e8)
+++ configure.ac	(revision f941b14c7a92d23575eccdfcd7bbb7ef127d1bad)
@@ -28,5 +28,5 @@
 # Boost libraries
 AX_BOOST_BASE([1.33.1])
-#AX_BOOST_PROGRAM_OPTIONS
+AX_BOOST_PROGRAM_OPTIONS
 #AX_BOOST_FOREACH
 #AX_BOOST_FILESYSTEM
Index: src/Actions/ActionRegistry.cpp
===================================================================
--- src/Actions/ActionRegistry.cpp	(revision 12872df33639e521d4b0225d6064ea91bd4f18e8)
+++ src/Actions/ActionRegistry.cpp	(revision f941b14c7a92d23575eccdfcd7bbb7ef127d1bad)
@@ -43,3 +43,17 @@
 }
 
+void ActionRegistry::unregisterAction(Action* action){
+  actionMap.erase(action->getName());
+}
+
+std::map<const std::string,Action*>::iterator ActionRegistry::getBeginIter()
+{
+  return actionMap.begin();
+}
+
+std::map<const std::string,Action*>::iterator ActionRegistry::getEndIter()
+{
+  return actionMap.end();
+}
+
 CONSTRUCT_SINGLETON(ActionRegistry)
Index: src/Actions/ActionRegistry.hpp
===================================================================
--- src/Actions/ActionRegistry.hpp	(revision 12872df33639e521d4b0225d6064ea91bd4f18e8)
+++ src/Actions/ActionRegistry.hpp	(revision f941b14c7a92d23575eccdfcd7bbb7ef127d1bad)
@@ -22,4 +22,8 @@
   Action* getActionByName(const std::string);
   void registerAction(Action*);
+  void unregisterAction(Action*);
+
+  std::map<const std::string,Action*>::iterator getBeginIter();
+  std::map<const std::string,Action*>::iterator getEndIter();
 
 private:
Index: src/Actions/AnalysisAction/MolecularVolumeAction.cpp
===================================================================
--- src/Actions/AnalysisAction/MolecularVolumeAction.cpp	(revision f941b14c7a92d23575eccdfcd7bbb7ef127d1bad)
+++ src/Actions/AnalysisAction/MolecularVolumeAction.cpp	(revision f941b14c7a92d23575eccdfcd7bbb7ef127d1bad)
@@ -0,0 +1,89 @@
+/*
+ * MolecularVolumeAction.cpp
+ *
+ *  Created on: May 12, 2010
+ *      Author: heber
+ */
+
+#include "Actions/AnalysisAction/MolecularVolumeAction.hpp"
+#include "CommandLineParser.hpp"
+#include "boundary.hpp"
+#include "config.hpp"
+#include "molecule.hpp"
+#include "linkedcell.hpp"
+#include "log.hpp"
+#include "verbose.hpp"
+#include "World.hpp"
+
+#include <iostream>
+#include <string>
+
+using namespace std;
+
+#include "UIElements/UIFactory.hpp"
+#include "UIElements/Dialog.hpp"
+#include "Actions/MapOfActions.hpp"
+
+const char AnalysisMolecularVolumeAction::NAME[] = "molecular-volume";
+
+AnalysisMolecularVolumeAction::AnalysisMolecularVolumeAction() :
+  Action(NAME)
+{}
+
+AnalysisMolecularVolumeAction::~AnalysisMolecularVolumeAction()
+{}
+
+Action::state_ptr AnalysisMolecularVolumeAction::performCall() {
+  Dialog *dialog = UIFactory::getInstance().makeDialog();
+  molecule *mol = NULL;
+
+  dialog->queryMolecule(NAME, &mol, MapOfActions::getInstance().getDescription(NAME));
+
+  if(dialog->display()) {
+    class Tesselation *TesselStruct = NULL;
+    const LinkedCell *LCList = NULL;
+    DoLog(0) && (Log() << Verbose(0) << "Evaluating volume of the convex envelope.");
+    LCList = new LinkedCell(mol, 10.);
+    config * const configuration = World::getInstance().getConfig();
+    //FindConvexBorder(mol, LCList, argv[argptr]);
+    FindNonConvexBorder(mol, TesselStruct, LCList, 5., NULL);
+    //RemoveAllBoundaryPoints(TesselStruct, mol, argv[argptr]);
+    double volumedifference = ConvexizeNonconvexEnvelope(TesselStruct, mol, NULL);
+    double clustervolume = VolumeOfConvexEnvelope(TesselStruct, configuration);
+    DoLog(0) && (Log() << Verbose(0) << "The tesselated volume area is " << clustervolume << " " << (configuration->GetIsAngstroem() ? "angstrom" : "atomiclength") << "^3." << endl);
+    DoLog(0) && (Log() << Verbose(0) << "The non-convex tesselated volume area is " << clustervolume-volumedifference << " " << (configuration->GetIsAngstroem() ? "angstrom" : "atomiclength") << "^3." << endl);
+    delete(TesselStruct);
+    delete(LCList);
+    delete dialog;
+    return Action::success;
+  } else {
+    delete dialog;
+    return Action::failure;
+  }
+}
+
+Action::state_ptr AnalysisMolecularVolumeAction::performUndo(Action::state_ptr _state) {
+//  ParserLoadXyzState *state = assert_cast<ParserLoadXyzState*>(_state.get());
+
+  return Action::failure;
+//  string newName = state->mol->getName();
+//  state->mol->setName(state->lastName);
+//
+//  return Action::state_ptr(new ParserLoadXyzState(state->mol,newName));
+}
+
+Action::state_ptr AnalysisMolecularVolumeAction::performRedo(Action::state_ptr _state){
+  return Action::failure;
+}
+
+bool AnalysisMolecularVolumeAction::canUndo() {
+  return false;
+}
+
+bool AnalysisMolecularVolumeAction::shouldUndo() {
+  return false;
+}
+
+const string AnalysisMolecularVolumeAction::getName() {
+  return NAME;
+}
Index: src/Actions/AnalysisAction/MolecularVolumeAction.hpp
===================================================================
--- src/Actions/AnalysisAction/MolecularVolumeAction.hpp	(revision f941b14c7a92d23575eccdfcd7bbb7ef127d1bad)
+++ src/Actions/AnalysisAction/MolecularVolumeAction.hpp	(revision f941b14c7a92d23575eccdfcd7bbb7ef127d1bad)
@@ -0,0 +1,30 @@
+/*
+ * MolecularVolumeAction.hpp
+ *
+ *  Created on: May 12, 2010
+ *      Author: heber
+ */
+
+#ifndef MOLECULARVOLUMEACTION_HPP_
+#define MOLECULARVOLUMEACTION_HPP_
+
+#include "Actions/Action.hpp"
+
+class AnalysisMolecularVolumeAction : public Action {
+public:
+  AnalysisMolecularVolumeAction();
+  virtual ~AnalysisMolecularVolumeAction();
+
+  bool canUndo();
+  bool shouldUndo();
+
+  virtual const std::string getName();
+private:
+  virtual Action::state_ptr performCall();
+  virtual Action::state_ptr performUndo(Action::state_ptr);
+  virtual Action::state_ptr performRedo(Action::state_ptr);
+
+  static const char NAME[];
+};
+
+#endif /* MOLECULARVOLUMEACTION_HPP_ */
Index: src/Actions/AnalysisAction/PairCorrelationAction.cpp
===================================================================
--- src/Actions/AnalysisAction/PairCorrelationAction.cpp	(revision f941b14c7a92d23575eccdfcd7bbb7ef127d1bad)
+++ src/Actions/AnalysisAction/PairCorrelationAction.cpp	(revision f941b14c7a92d23575eccdfcd7bbb7ef127d1bad)
@@ -0,0 +1,102 @@
+/*
+ * PairCorrelationAction.cpp
+ *
+ *  Created on: May 9, 2010
+ *      Author: heber
+ */
+
+#include "Actions/AnalysisAction/PairCorrelationAction.hpp"
+#include "CommandLineParser.hpp"
+#include "analysis_correlation.hpp"
+#include "log.hpp"
+#include "element.hpp"
+#include "periodentafel.hpp"
+#include "World.hpp"
+
+#include <iostream>
+#include <string>
+
+using namespace std;
+
+#include "UIElements/UIFactory.hpp"
+#include "UIElements/Dialog.hpp"
+#include "Actions/MapOfActions.hpp"
+
+const char AnalysisPairCorrelationAction::NAME[] = "pair-correlation";
+
+AnalysisPairCorrelationAction::AnalysisPairCorrelationAction() :
+  Action(NAME)
+{}
+
+AnalysisPairCorrelationAction::~AnalysisPairCorrelationAction()
+{}
+
+Action::state_ptr AnalysisPairCorrelationAction::performCall() {
+  Dialog *dialog = UIFactory::getInstance().makeDialog();
+  int ranges[3] = {1, 1, 1};
+  double BinStart = 0.;
+  double BinEnd = 0.;
+  string outputname;
+  string binoutputname;
+  bool periodic;
+  ofstream output;
+  ofstream binoutput;
+  const element *elemental1;
+  const element *elemental2;
+
+  dialog->queryElement("elements", &elemental1, MapOfActions::getInstance().getDescription("elements"));
+  dialog->queryElement("elements", &elemental2, MapOfActions::getInstance().getDescription("elements"));
+  dialog->queryDouble("bin-start", &BinStart, MapOfActions::getInstance().getDescription("bin-start"));
+  dialog->queryDouble("bin-end", &BinEnd, MapOfActions::getInstance().getDescription("bin-end"));
+  dialog->queryString("output-file", &outputname, MapOfActions::getInstance().getDescription("output-file"));
+  dialog->queryString("bin-output-file", &binoutputname, MapOfActions::getInstance().getDescription("bin-output-file"));
+  dialog->queryBoolean("periodic", &periodic, MapOfActions::getInstance().getDescription("periodic"));
+
+  if(dialog->display()) {
+    output.open(outputname.c_str());
+    binoutput.open(binoutputname.c_str());
+    PairCorrelationMap *correlationmap = NULL;
+    if (periodic)
+      correlationmap = PeriodicPairCorrelation(World::getInstance().getMolecules(), elemental1, elemental2, ranges);
+    else
+      correlationmap = PairCorrelation(World::getInstance().getMolecules(), elemental1, elemental2);
+    //OutputCorrelationToSurface(&output, correlationmap);
+    BinPairMap *binmap = BinData( correlationmap, 0.5, BinStart, BinEnd );
+    OutputCorrelation ( &binoutput, binmap );
+    output.close();
+    binoutput.close();
+    delete(binmap);
+    delete(correlationmap);
+    delete dialog;
+    return Action::success;
+  } else {
+    delete dialog;
+    return Action::failure;
+  }
+}
+
+Action::state_ptr AnalysisPairCorrelationAction::performUndo(Action::state_ptr _state) {
+//  ParserLoadXyzState *state = assert_cast<ParserLoadXyzState*>(_state.get());
+
+  return Action::failure;
+//  string newName = state->mol->getName();
+//  state->mol->setName(state->lastName);
+//
+//  return Action::state_ptr(new ParserLoadXyzState(state->mol,newName));
+}
+
+Action::state_ptr AnalysisPairCorrelationAction::performRedo(Action::state_ptr _state){
+  return Action::failure;
+}
+
+bool AnalysisPairCorrelationAction::canUndo() {
+  return false;
+}
+
+bool AnalysisPairCorrelationAction::shouldUndo() {
+  return false;
+}
+
+const string AnalysisPairCorrelationAction::getName() {
+  return NAME;
+}
Index: src/Actions/AnalysisAction/PairCorrelationAction.hpp
===================================================================
--- src/Actions/AnalysisAction/PairCorrelationAction.hpp	(revision f941b14c7a92d23575eccdfcd7bbb7ef127d1bad)
+++ src/Actions/AnalysisAction/PairCorrelationAction.hpp	(revision f941b14c7a92d23575eccdfcd7bbb7ef127d1bad)
@@ -0,0 +1,30 @@
+/*
+ * PairCorrelationAction.hpp
+ *
+ *  Created on: May 9, 2010
+ *      Author: heber
+ */
+
+#ifndef PAIRCORRELATIONACTION_HPP_
+#define PAIRCORRELATIONACTION_HPP_
+
+#include "Actions/Action.hpp"
+
+class AnalysisPairCorrelationAction : public Action {
+public:
+  AnalysisPairCorrelationAction();
+  virtual ~AnalysisPairCorrelationAction();
+
+  bool canUndo();
+  bool shouldUndo();
+
+  virtual const std::string getName();
+private:
+  virtual Action::state_ptr performCall();
+  virtual Action::state_ptr performUndo(Action::state_ptr);
+  virtual Action::state_ptr performRedo(Action::state_ptr);
+
+  static const char NAME[];
+};
+
+#endif /* PAIRCORRELATIONACTION_HPP_ */
Index: src/Actions/AnalysisAction/PairCorrelationToPointAction.cpp
===================================================================
--- src/Actions/AnalysisAction/PairCorrelationToPointAction.cpp	(revision f941b14c7a92d23575eccdfcd7bbb7ef127d1bad)
+++ src/Actions/AnalysisAction/PairCorrelationToPointAction.cpp	(revision f941b14c7a92d23575eccdfcd7bbb7ef127d1bad)
@@ -0,0 +1,103 @@
+/*
+ * PairCorrelationToPointAction.cpp
+ *
+ *  Created on: May 9, 2010
+ *      Author: heber
+ */
+
+#include "Actions/AnalysisAction/PairCorrelationToPointAction.hpp"
+#include "CommandLineParser.hpp"
+#include "analysis_correlation.hpp"
+#include "log.hpp"
+#include "element.hpp"
+#include "periodentafel.hpp"
+#include "World.hpp"
+
+#include <iostream>
+#include <string>
+
+using namespace std;
+
+#include "UIElements/UIFactory.hpp"
+#include "UIElements/Dialog.hpp"
+#include "Actions/MapOfActions.hpp"
+
+const char AnalysisPairCorrelationToPointAction::NAME[] = "pair-correlation-point";
+
+AnalysisPairCorrelationToPointAction::AnalysisPairCorrelationToPointAction() :
+  Action(NAME)
+{}
+
+AnalysisPairCorrelationToPointAction::~AnalysisPairCorrelationToPointAction()
+{}
+
+Action::state_ptr AnalysisPairCorrelationToPointAction::performCall() {
+  Dialog *dialog = UIFactory::getInstance().makeDialog();
+  int ranges[3] = {1, 1, 1};
+  Vector position;
+  double BinStart = 0.;
+  double BinEnd = 0.;
+  string outputname;
+  string binoutputname;
+  bool periodic;
+  ofstream output;
+  ofstream binoutput;
+  const element *elemental;
+
+  dialog->queryElement("elements", &elemental, MapOfActions::getInstance().getDescription("element"));
+  dialog->queryVector("position", &position, World::getInstance().getDomain(), true, MapOfActions::getInstance().getDescription("position"));
+  dialog->queryDouble("bin-start", &BinStart, MapOfActions::getInstance().getDescription("bin-start"));
+  dialog->queryDouble("bin-end", &BinEnd, MapOfActions::getInstance().getDescription("bin-end"));
+  dialog->queryString("output-file", &outputname, MapOfActions::getInstance().getDescription("output-file"));
+  dialog->queryString("bin-output-file", &binoutputname, MapOfActions::getInstance().getDescription("bin-output-file"));
+  dialog->queryBoolean("periodic", &periodic, MapOfActions::getInstance().getDescription("periodic"));
+
+  if(dialog->display()) {
+    output.open(outputname.c_str());
+    binoutput.open(binoutputname.c_str());
+    const Vector Point = position;
+    CorrelationToPointMap *correlationmap = NULL;
+    if (periodic)
+      correlationmap  = PeriodicCorrelationToPoint(World::getInstance().getMolecules(), elemental, &Point, ranges);
+    else
+      correlationmap = CorrelationToPoint(World::getInstance().getMolecules(), elemental, &Point);
+    //OutputCorrelationToSurface(&output, correlationmap);
+    BinPairMap *binmap = BinData( correlationmap, 0.5, BinStart, BinEnd );
+    OutputCorrelation ( &binoutput, binmap );
+    output.close();
+    binoutput.close();
+    delete(binmap);
+    delete(correlationmap);
+    delete dialog;
+    return Action::success;
+  } else {
+    delete dialog;
+    return Action::failure;
+  }
+}
+
+Action::state_ptr AnalysisPairCorrelationToPointAction::performUndo(Action::state_ptr _state) {
+//  ParserLoadXyzState *state = assert_cast<ParserLoadXyzState*>(_state.get());
+
+  return Action::failure;
+//  string newName = state->mol->getName();
+//  state->mol->setName(state->lastName);
+//
+//  return Action::state_ptr(new ParserLoadXyzState(state->mol,newName));
+}
+
+Action::state_ptr AnalysisPairCorrelationToPointAction::performRedo(Action::state_ptr _state){
+  return Action::failure;
+}
+
+bool AnalysisPairCorrelationToPointAction::canUndo() {
+  return false;
+}
+
+bool AnalysisPairCorrelationToPointAction::shouldUndo() {
+  return false;
+}
+
+const string AnalysisPairCorrelationToPointAction::getName() {
+  return NAME;
+}
Index: src/Actions/AnalysisAction/PairCorrelationToPointAction.hpp
===================================================================
--- src/Actions/AnalysisAction/PairCorrelationToPointAction.hpp	(revision f941b14c7a92d23575eccdfcd7bbb7ef127d1bad)
+++ src/Actions/AnalysisAction/PairCorrelationToPointAction.hpp	(revision f941b14c7a92d23575eccdfcd7bbb7ef127d1bad)
@@ -0,0 +1,30 @@
+/*
+ * PairCorrelationToPointAction.hpp
+ *
+ *  Created on: May 9, 2010
+ *      Author: heber
+ */
+
+#ifndef PAIRCORRELATIONTOPOINTACTION_HPP_
+#define PAIRCORRELATIONTOPOINTACTION_HPP_
+
+#include "Actions/Action.hpp"
+
+class AnalysisPairCorrelationToPointAction : public Action {
+public:
+  AnalysisPairCorrelationToPointAction();
+  virtual ~AnalysisPairCorrelationToPointAction();
+
+  bool canUndo();
+  bool shouldUndo();
+
+  virtual const std::string getName();
+private:
+  virtual Action::state_ptr performCall();
+  virtual Action::state_ptr performUndo(Action::state_ptr);
+  virtual Action::state_ptr performRedo(Action::state_ptr);
+
+  static const char NAME[];
+};
+
+#endif /* PAIRCORRELATIONTOPOINTACTION_HPP_ */
Index: src/Actions/AnalysisAction/PairCorrelationToSurfaceAction.cpp
===================================================================
--- src/Actions/AnalysisAction/PairCorrelationToSurfaceAction.cpp	(revision f941b14c7a92d23575eccdfcd7bbb7ef127d1bad)
+++ src/Actions/AnalysisAction/PairCorrelationToSurfaceAction.cpp	(revision f941b14c7a92d23575eccdfcd7bbb7ef127d1bad)
@@ -0,0 +1,128 @@
+/*
+ * PairCorrelationToSurfaceAction.cpp
+ *
+ *  Created on: May 9, 2010
+ *      Author: heber
+ */
+
+#include "Actions/AnalysisAction/PairCorrelationToSurfaceAction.hpp"
+#include "CommandLineParser.hpp"
+#include "analysis_correlation.hpp"
+#include "boundary.hpp"
+#include "element.hpp"
+#include "linkedcell.hpp"
+#include "log.hpp"
+#include "molecule.hpp"
+#include "verbose.hpp"
+#include "World.hpp"
+
+#include <iostream>
+#include <string>
+
+using namespace std;
+
+#include "UIElements/UIFactory.hpp"
+#include "UIElements/Dialog.hpp"
+#include "Actions/MapOfActions.hpp"
+
+const char AnalysisPairCorrelationToSurfaceAction::NAME[] = "pair-correlation-surface";
+
+AnalysisPairCorrelationToSurfaceAction::AnalysisPairCorrelationToSurfaceAction() :
+  Action(NAME)
+{}
+
+AnalysisPairCorrelationToSurfaceAction::~AnalysisPairCorrelationToSurfaceAction()
+{}
+
+Action::state_ptr AnalysisPairCorrelationToSurfaceAction::performCall() {
+  Dialog *dialog = UIFactory::getInstance().makeDialog();
+  double BinStart = 0.;
+  double BinWidth = 0.;
+  double BinEnd = 0.;
+  string outputname;
+  string binoutputname;
+  bool periodic;
+  ofstream output;
+  ofstream binoutput;
+  int ranges[3] = {1, 1, 1};
+  const element *elemental = NULL;
+  molecule *Boundary = NULL;
+
+  dialog->queryElement("elements", &elemental, MapOfActions::getInstance().getDescription("element"));
+  dialog->queryMolecule("molecule-by-id", &Boundary, MapOfActions::getInstance().getDescription("molecule-by-id"));
+  dialog->queryDouble("bin-start", &BinStart, MapOfActions::getInstance().getDescription("bin-start"));
+  dialog->queryDouble("bin-end", &BinEnd, MapOfActions::getInstance().getDescription("bin-end"));
+  dialog->queryString("output-file", &outputname, MapOfActions::getInstance().getDescription("output-file"));
+  dialog->queryString("bin-output-file", &binoutputname, MapOfActions::getInstance().getDescription("bin-output-file"));
+  dialog->queryBoolean("periodic", &periodic, MapOfActions::getInstance().getDescription("periodic"));
+
+  if(dialog->display()) {
+    output.open(outputname.c_str());
+    binoutput.open(binoutputname.c_str());
+    const double radius = 4.;
+    double LCWidth = 20.;
+    if (BinEnd > 0) {
+      if (BinEnd > 2.*radius)
+          LCWidth = BinEnd;
+      else
+        LCWidth = 2.*radius;
+    }
+    class MoleculeListClass *molecules = World::getInstance().getMolecules();
+    class Tesselation *TesselStruct = NULL;
+    const LinkedCell *LCList = NULL;
+    LCList = new LinkedCell(Boundary, LCWidth);
+    FindNonConvexBorder(Boundary, TesselStruct, LCList, radius, NULL);
+    CorrelationToSurfaceMap *surfacemap = NULL;
+    if (periodic)
+      surfacemap = PeriodicCorrelationToSurface( molecules, elemental, TesselStruct, LCList, ranges);
+    else
+      surfacemap = CorrelationToSurface( molecules, elemental, TesselStruct, LCList);
+    OutputCorrelationToSurface(&output, surfacemap);
+    // check whether radius was appropriate
+    {
+      double start; double end;
+      GetMinMax( surfacemap, start, end);
+      if (LCWidth < end)
+        DoeLog(1) && (eLog()<< Verbose(1) << "Linked Cell width is smaller than the found range of values! Bins can only be correct up to: " << radius << "." << endl);
+    }
+    BinPairMap *binmap = BinData( surfacemap, BinWidth, BinStart, BinEnd );
+    OutputCorrelation ( &binoutput, binmap );
+    output.close();
+    binoutput.close();
+    delete(LCList);
+    delete(TesselStruct);
+    delete(binmap);
+    delete(surfacemap);
+    delete dialog;
+    return Action::success;
+  } else {
+    delete dialog;
+    return Action::failure;
+  }
+}
+
+Action::state_ptr AnalysisPairCorrelationToSurfaceAction::performUndo(Action::state_ptr _state) {
+//  ParserLoadXyzState *state = assert_cast<ParserLoadXyzState*>(_state.get());
+
+  return Action::failure;
+//  string newName = state->mol->getName();
+//  state->mol->setName(state->lastName);
+//
+//  return Action::state_ptr(new ParserLoadXyzState(state->mol,newName));
+}
+
+Action::state_ptr AnalysisPairCorrelationToSurfaceAction::performRedo(Action::state_ptr _state){
+  return Action::failure;
+}
+
+bool AnalysisPairCorrelationToSurfaceAction::canUndo() {
+  return false;
+}
+
+bool AnalysisPairCorrelationToSurfaceAction::shouldUndo() {
+  return false;
+}
+
+const string AnalysisPairCorrelationToSurfaceAction::getName() {
+  return NAME;
+}
Index: src/Actions/AnalysisAction/PairCorrelationToSurfaceAction.hpp
===================================================================
--- src/Actions/AnalysisAction/PairCorrelationToSurfaceAction.hpp	(revision f941b14c7a92d23575eccdfcd7bbb7ef127d1bad)
+++ src/Actions/AnalysisAction/PairCorrelationToSurfaceAction.hpp	(revision f941b14c7a92d23575eccdfcd7bbb7ef127d1bad)
@@ -0,0 +1,30 @@
+/*
+ * PairCorrelationToSurfaceAction.hpp
+ *
+ *  Created on: May 9, 2010
+ *      Author: heber
+ */
+
+#ifndef PAIRCORRELATIONTOSURFACEACTION_HPP_
+#define PAIRCORRELATIONTOSURFACEACTION_HPP_
+
+#include "Actions/Action.hpp"
+
+class AnalysisPairCorrelationToSurfaceAction : public Action {
+public:
+  AnalysisPairCorrelationToSurfaceAction();
+  virtual ~AnalysisPairCorrelationToSurfaceAction();
+
+  bool canUndo();
+  bool shouldUndo();
+
+  virtual const std::string getName();
+private:
+  virtual Action::state_ptr performCall();
+  virtual Action::state_ptr performUndo(Action::state_ptr);
+  virtual Action::state_ptr performRedo(Action::state_ptr);
+
+  static const char NAME[];
+};
+
+#endif /* PAIRCORRELATIONTOSURFACEACTION_HPP_ */
Index: src/Actions/AnalysisAction/PrincipalAxisSystemAction.cpp
===================================================================
--- src/Actions/AnalysisAction/PrincipalAxisSystemAction.cpp	(revision f941b14c7a92d23575eccdfcd7bbb7ef127d1bad)
+++ src/Actions/AnalysisAction/PrincipalAxisSystemAction.cpp	(revision f941b14c7a92d23575eccdfcd7bbb7ef127d1bad)
@@ -0,0 +1,73 @@
+/*
+ * PrincipalAxisSystemAction.cpp
+ *
+ *  Created on: May 12, 2010
+ *      Author: heber
+ */
+
+#include "Actions/AnalysisAction/PrincipalAxisSystemAction.hpp"
+#include "CommandLineParser.hpp"
+#include "molecule.hpp"
+#include "log.hpp"
+#include "verbose.hpp"
+
+#include <iostream>
+#include <string>
+
+using namespace std;
+
+#include "UIElements/UIFactory.hpp"
+#include "UIElements/Dialog.hpp"
+#include "Actions/MapOfActions.hpp"
+
+const char AnalysisPrincipalAxisSystemAction::NAME[] = "principal-axis-system";
+
+AnalysisPrincipalAxisSystemAction::AnalysisPrincipalAxisSystemAction() :
+  Action(NAME)
+{}
+
+AnalysisPrincipalAxisSystemAction::~AnalysisPrincipalAxisSystemAction()
+{}
+
+Action::state_ptr AnalysisPrincipalAxisSystemAction::performCall() {
+  Dialog *dialog = UIFactory::getInstance().makeDialog();
+  molecule *mol = NULL;
+
+  dialog->queryMolecule(NAME, &mol, MapOfActions::getInstance().getDescription(NAME));
+
+  if(dialog->display()) {
+    DoLog(0) && (Log() << Verbose(0) << "Evaluating prinicipal axis." << endl);
+    mol->PrincipalAxisSystem(false);
+    delete dialog;
+    return Action::success;
+  } else {
+    delete dialog;
+    return Action::failure;
+  }
+}
+
+Action::state_ptr AnalysisPrincipalAxisSystemAction::performUndo(Action::state_ptr _state) {
+//  ParserLoadXyzState *state = assert_cast<ParserLoadXyzState*>(_state.get());
+
+  return Action::failure;
+//  string newName = state->mol->getName();
+//  state->mol->setName(state->lastName);
+//
+//  return Action::state_ptr(new ParserLoadXyzState(state->mol,newName));
+}
+
+Action::state_ptr AnalysisPrincipalAxisSystemAction::performRedo(Action::state_ptr _state){
+  return Action::failure;
+}
+
+bool AnalysisPrincipalAxisSystemAction::canUndo() {
+  return false;
+}
+
+bool AnalysisPrincipalAxisSystemAction::shouldUndo() {
+  return false;
+}
+
+const string AnalysisPrincipalAxisSystemAction::getName() {
+  return NAME;
+}
Index: src/Actions/AnalysisAction/PrincipalAxisSystemAction.hpp
===================================================================
--- src/Actions/AnalysisAction/PrincipalAxisSystemAction.hpp	(revision f941b14c7a92d23575eccdfcd7bbb7ef127d1bad)
+++ src/Actions/AnalysisAction/PrincipalAxisSystemAction.hpp	(revision f941b14c7a92d23575eccdfcd7bbb7ef127d1bad)
@@ -0,0 +1,30 @@
+/*
+ * PrincipalAxisSystemAction.hpp
+ *
+ *  Created on: May 12, 2010
+ *      Author: heber
+ */
+
+#ifndef PRINCIPALAXISSYSTEMACTION_HPP_
+#define PRINCIPALAXISSYSTEMACTION_HPP_
+
+#include "Actions/Action.hpp"
+
+class AnalysisPrincipalAxisSystemAction : public Action {
+public:
+  AnalysisPrincipalAxisSystemAction();
+  virtual ~AnalysisPrincipalAxisSystemAction();
+
+  bool canUndo();
+  bool shouldUndo();
+
+  virtual const std::string getName();
+private:
+  virtual Action::state_ptr performCall();
+  virtual Action::state_ptr performUndo(Action::state_ptr);
+  virtual Action::state_ptr performRedo(Action::state_ptr);
+
+  static const char NAME[];
+};
+
+#endif /* PRINCIPALAXISSYSTEMACTION_HPP_ */
Index: src/Actions/AtomAction/AddAction.cpp
===================================================================
--- src/Actions/AtomAction/AddAction.cpp	(revision f941b14c7a92d23575eccdfcd7bbb7ef127d1bad)
+++ src/Actions/AtomAction/AddAction.cpp	(revision f941b14c7a92d23575eccdfcd7bbb7ef127d1bad)
@@ -0,0 +1,88 @@
+/*
+ * AddAction.cpp
+ *
+ *  Created on: May 9, 2010
+ *      Author: heber
+ */
+
+#include "Actions/AtomAction/AddAction.hpp"
+#include "CommandLineParser.hpp"
+#include "atom.hpp"
+#include "element.hpp"
+#include "log.hpp"
+#include "periodentafel.hpp"
+#include "vector.hpp"
+#include "verbose.hpp"
+#include "World.hpp"
+
+#include <iostream>
+#include <string>
+
+using namespace std;
+
+#include "UIElements/UIFactory.hpp"
+#include "UIElements/Dialog.hpp"
+#include "Actions/MapOfActions.hpp"
+
+const char AtomAddAction::NAME[] = "add-atom";
+
+AtomAddAction::AtomAddAction() :
+  Action(NAME)
+{}
+
+AtomAddAction::~AtomAddAction()
+{}
+
+Action::state_ptr AtomAddAction::performCall() {
+  Dialog *dialog = UIFactory::getInstance().makeDialog();
+  int Z = -1;
+  Vector position;
+
+  dialog->queryInt(NAME, &Z, MapOfActions::getInstance().getDescription(NAME));
+  dialog->queryVector("position", &position, World::getInstance().getDomain(), true, MapOfActions::getInstance().getDescription("position"));
+
+  if(dialog->display()) {
+    delete dialog;
+    atom * first = World::getInstance().createAtom();
+    first->type = World::getInstance().getPeriode()->FindElement(Z);
+    first->x = position;
+    if (first->type != NULL) {
+      DoLog(1) && (Log() << Verbose(1) << "Adding new atom with element " << first->type->name << " at " << (first->x) << "." << endl);
+      return Action::success;
+    } else {
+      DoeLog(1) && (eLog()<< Verbose(1) << "Could not find the specified element." << endl);
+      World::getInstance().destroyAtom(first);
+      return Action::failure;
+    }
+  } else {
+    delete dialog;
+    return Action::failure;
+  }
+
+}
+
+Action::state_ptr AtomAddAction::performUndo(Action::state_ptr _state) {
+//  ParserLoadXyzState *state = assert_cast<ParserLoadXyzState*>(_state.get());
+
+  return Action::failure;
+//  string newName = state->mol->getName();
+//  state->mol->setName(state->lastName);
+//
+//  return Action::state_ptr(new ParserLoadXyzState(state->mol,newName));
+}
+
+Action::state_ptr AtomAddAction::performRedo(Action::state_ptr _state){
+  return Action::failure;
+}
+
+bool AtomAddAction::canUndo() {
+  return false;
+}
+
+bool AtomAddAction::shouldUndo() {
+  return false;
+}
+
+const string AtomAddAction::getName() {
+  return NAME;
+}
Index: src/Actions/AtomAction/AddAction.hpp
===================================================================
--- src/Actions/AtomAction/AddAction.hpp	(revision f941b14c7a92d23575eccdfcd7bbb7ef127d1bad)
+++ src/Actions/AtomAction/AddAction.hpp	(revision f941b14c7a92d23575eccdfcd7bbb7ef127d1bad)
@@ -0,0 +1,30 @@
+/*
+ * AddAction.hpp
+ *
+ *  Created on: May 9, 2010
+ *      Author: heber
+ */
+
+#ifndef ADDACTION_HPP_
+#define ADDACTION_HPP_
+
+#include "Actions/Action.hpp"
+
+class AtomAddAction : public Action {
+public:
+  AtomAddAction();
+  virtual ~AtomAddAction();
+
+  bool canUndo();
+  bool shouldUndo();
+
+  virtual const std::string getName();
+private:
+  virtual Action::state_ptr performCall();
+  virtual Action::state_ptr performUndo(Action::state_ptr);
+  virtual Action::state_ptr performRedo(Action::state_ptr);
+
+  static const char NAME[];
+};
+
+#endif /* ADDACTION_HPP_ */
Index: src/Actions/AtomAction/ChangeElementAction.cpp
===================================================================
--- src/Actions/AtomAction/ChangeElementAction.cpp	(revision f941b14c7a92d23575eccdfcd7bbb7ef127d1bad)
+++ src/Actions/AtomAction/ChangeElementAction.cpp	(revision f941b14c7a92d23575eccdfcd7bbb7ef127d1bad)
@@ -0,0 +1,82 @@
+/*
+ * ChangeElementAction.cpp
+ *
+ *  Created on: May 9, 2010
+ *      Author: heber
+ */
+
+#include "Actions/AtomAction/ChangeElementAction.hpp"
+#include "CommandLineParser.hpp"
+#include "atom.hpp"
+#include "log.hpp"
+#include "vector.hpp"
+#include "verbose.hpp"
+#include "World.hpp"
+
+#include <iostream>
+#include <string>
+
+using namespace std;
+
+#include "UIElements/UIFactory.hpp"
+#include "UIElements/Dialog.hpp"
+#include "Actions/MapOfActions.hpp"
+
+const char AtomChangeElementAction::NAME[] = "change-element";
+
+AtomChangeElementAction::AtomChangeElementAction() :
+  Action(NAME)
+{}
+
+AtomChangeElementAction::~AtomChangeElementAction()
+{}
+
+Action::state_ptr AtomChangeElementAction::performCall() {
+  Dialog *dialog = UIFactory::getInstance().makeDialog();
+  int Z = -1;
+  atom *first = NULL;
+  element *elemental = NULL;
+
+  dialog->queryElement(NAME, (const element **) &elemental, MapOfActions::getInstance().getDescription(NAME));
+  dialog->queryAtom("atom-by-id", &first, MapOfActions::getInstance().getDescription("atom-by-id"));
+
+  if(dialog->display()) {
+    delete dialog;
+    DoLog(1) && (Log() << Verbose(1) << "Changing atom " << *first << " to element " << elemental << "." << endl);
+    if (elemental != NULL) {
+      first->type = elemental;
+      return Action::success;
+    } else
+      return Action::failure;
+  } else {
+    delete dialog;
+    return Action::failure;
+  }
+
+}
+
+Action::state_ptr AtomChangeElementAction::performUndo(Action::state_ptr _state) {
+//  ParserLoadXyzState *state = assert_cast<ParserLoadXyzState*>(_state.get());
+
+  return Action::failure;
+//  string newName = state->mol->getName();
+//  state->mol->setName(state->lastName);
+//
+//  return Action::state_ptr(new ParserLoadXyzState(state->mol,newName));
+}
+
+Action::state_ptr AtomChangeElementAction::performRedo(Action::state_ptr _state){
+  return Action::failure;
+}
+
+bool AtomChangeElementAction::canUndo() {
+  return false;
+}
+
+bool AtomChangeElementAction::shouldUndo() {
+  return false;
+}
+
+const string AtomChangeElementAction::getName() {
+  return NAME;
+}
